package tests

import (
	"bytes"
	"lux/net"
	"testing"
)

func TestRecvSend(t *testing.T) {
	sv, err := net.NewLuxInboundChannel("127.0.0.2:65535", net.LuxChannelInterior)
	if err != nil {
		t.Fatal(t)
	}

	cl, err := net.NewLuxOutboundChannel("127.0.0.2:65535", net.LuxChannelInterior)
	if err != nil {
		t.Fatal(t)
	}

	dgram := net.LuxDatagram{Payload: []byte("TEEEESTTTT 3243492i0423")}
	if err := cl.Send(dgram); err != nil {
		t.Fatal(err)
	}

	recv, err := sv.Recv()
	if err != nil {
		t.Fatal(err)
	}

	if !bytes.Equal(dgram.Payload, recv.Payload) {
		t.Log(dgram)
		t.Log(recv)
		t.Fatal("sent and recv payload not equal!")
	}
}
