package tests

import (
	"lux/rpc"
	"testing"
)

func TestRequestDef(t *testing.T) {
	def := rpc.NewLuxRpcDefrag()

	t.Log(def.Feed([]byte("<request >tee")))
	t.Log(def.Feed([]byte("st</request>")))

	if !def.HasRequest() {
		t.Fatal("!def.HasRequest()")
	}
	t.Log(string(def.GetAndForget()))
}

func TestPreambleResponseDef(t *testing.T) {
	def := rpc.NewLuxRpcDefrag()

	t.Log(def.Feed([]byte(`<?xml version="1.0" encoding="UTF-8"?><response >tee`)))
	t.Log(def.Feed([]byte("st</response>")))

	if !def.HasResponse() {
		t.Fatal("!def.HasResponse()")
	}
	t.Log(string(def.GetAndForget()))
}

func TestErrorDef(t *testing.T) {
	def := rpc.NewLuxRpcDefrag()

	t.Log(def.Feed([]byte(`<?xml version="1.0" encoding="UTF-8"?>`)))
	t.Log(def.Feed([]byte("<error>teest</error>")))

	if !def.HasError() {
		t.Fatal("!def.HasError()")
	}
	t.Log(string(def.GetAndForget()))
}
